#!/usr/bin/env python

#    Written by Mark Mayfield. MMMC uses support programs to perform a 
#    variety of multimedia conversions.
#    Copyright (C) 2012  Mark Mayfield
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

import gtk, gobject, re, os, pwd, sys, subprocess, math, time, random

file_name = sys.path[0] + "/Multimedia.png"
home = pwd.getpwuid(os.getuid()).pw_dir

class NotebookExample:

    def filechoose(self, widget):
	chooser = gtk.FileChooserDialog(title="Output Filename - Only .avi extension!",action=gtk.FILE_CHOOSER_ACTION_SAVE, buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OK,gtk.RESPONSE_OK))
	chooser.set_icon_from_file(file_name)
	response = chooser.run()
	if response == gtk.RESPONSE_OK:
		filename = chooser.get_filename()
		chooser.destroy()
		self.merge(filename)
	elif response == gtk.RESPONSE_CANCEL:
		chooser.destroy()

    def progress(self, cmd):
	self.window.hide()
	win=gtk.Window(gtk.WINDOW_TOPLEVEL)
	win.set_title('MMMC')
	win.set_deletable(0)
	win.set_icon_from_file(file_name)
	self.win = win
	waitframe = gtk.Frame()
	waitframe.set_border_width(25)
	waitframe.set_size_request(450, 200)
	waitlabel = gtk.Label("Job in Progress... Please Wait")
	pb = gtk.ProgressBar()
        self.pb = pb
        box = gtk.VBox()
	pbbox = gtk.HBox()
        self.win.show_all()
        self.keep_pulsing = False
        self.keep_pulsing = True
    	def do_pulse(*args):
        	if self.keep_pulsing:
        		self.pb.pulse()
           		return True
       		return False

	box.pack_start(waitlabel, padding=25)
	pbbox.pack_start(self.pb, padding=40)
        box.pack_start(pbbox, padding=25)
	waitframe.add(box)
	self.win.add(waitframe)
	self.win.show_all()
	gtk.gdk.flush()
	def tester():
		if p.poll() is None:
			return True
		else:
			self.win.destroy()
			self.window.show()
	gobject.idle_add(tester)
	p = subprocess.Popen(cmd, shell=True)
        gobject.timeout_add(200, do_pulse)

    def merge(self, filename):

	files = ''
	files = self.textbuffer.get_text(*self.textbuffer.get_bounds())
	files = files.strip().split('\n')	
	files = re.sub('\', \'', '',str(files)[2:-2])
	cmd = 'mencoder ' + files + ' -ovc copy -oac mp3lame -lameopts fast:preset=standard -o ' + re.escape(filename) + ' 2>' + home + '/errors.txt'
	self.progress(cmd)

    def	file_select(self, widget, contype):
	dialog = gtk.FileChooserDialog("Select File...",None,gtk.FILE_CHOOSER_ACTION_OPEN,
		(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN, gtk.RESPONSE_OK))
	dialog.set_icon_from_file(file_name)
	dialog.set_default_response(gtk.RESPONSE_OK)

	filter = gtk.FileFilter()
	filter.set_name("All files")
	filter.add_pattern("*")
	dialog.add_filter(filter)

	vidfilter = gtk.FileFilter()
	imagefilter = gtk.FileFilter()
	vidfilter.set_name("Video Files")
	imagefilter.add_mime_type("image/png")
	imagefilter.add_mime_type("image/jpeg")
	imagefilter.add_mime_type("image/gif")
	vidfilter.add_pattern("*.flv")
	vidfilter.add_pattern("*.avi")
	vidfilter.add_pattern("*.mkv")
	vidfilter.add_pattern("*.ogv")
	vidfilter.add_pattern("*.mp4")
	vidfilter.add_pattern("*.mpeg")
	vidfilter.add_pattern("*.rmvb")
	vidfilter.add_pattern("*.mpg")
	audfilter = gtk.FileFilter()
	audfilter.set_name("Audio Files")
	audfilter.add_pattern("*.mp3")
	audfilter.add_pattern("*.m4a")
	audfilter.add_pattern("*.aac")
	audfilter.add_pattern("*.ogg")
	audfilter.add_pattern("*.mpc")
	audfilter.add_pattern("*.wav")
	audfilter.add_pattern("*.flac")
	dialog.add_filter(audfilter)
	dialog.add_filter(vidfilter)
	if 'audaud' in contype:
		dialog.set_filter(audfilter)
	elif 'merge' in contype or 'split' in contype or 'audvid' in contype:
		dialog.set_filter(vidfilter)

	response = dialog.run()
	if response == gtk.RESPONSE_OK:
		value = dialog.get_filename()
		if 'merge' in contype:
			(iter_first, iter_last) = self.textbuffer.get_bounds()
			if (re.escape(self.textbuffer.get_text(iter_first, iter_last)) == ''):
				value2 = value
			else:
				value2 = self.textbuffer.get_text(iter_first, iter_last) + ' \n' + value
			self.textbuffer.set_text(value2)
		elif 'split' in contype:
			self.splitentry.set_text(value)
		elif 'audvid' in contype:
			self.audvidentry.set_text(value)
		elif 'audaud' in contype:
			self.audaudentry.set_text(value)	
	dialog.destroy()

    def split(self, widget):
	hours = int(self.entry2.get_text())
	minutes = int(self.entry3.get_text())
	total = (hours*60)+minutes
	cmd="mplayer -vo null -ao null -frames 0 -identify " + re.escape(self.splitentry.get_text()) + " | grep ID_LENGTH | cut -f 2 -d ="
	run = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE)
	length=0
	for line in run.stdout.readlines():
		if line != "":
			length = re.sub("\n", '', line)
	length = int(math.ceil(float(length)/60))
	if total > 0:
		base, ext = os.path.split(re.escape(self.splitentry.get_text()))
		newname2 = re.sub('[^.]+$', '',ext)
		newname3 = re.sub('\.', '',newname2)
		hourp = 00
		minp = 00
		count = 0
		part = 1
		cmd=''
		while ( count < length ):
			cmd += 'mencoder ' + re.escape(self.splitentry.get_text()) + ' -oac mp3lame -ovc copy -ss ' + str(hourp) + ':' + str(minp) + ':00 -endpos ' + str(hours) + ':' + str(minutes) + ':00 -o ' + home + '/Desktop/' + newname3 + '_part_' + str(part) + '.avi 2>' + home + '/errors.txt && '	
			count += total
			part += 1
			minp += total
			hourp = hourp + minp/60
			minp = minp%60
		cmd = cmd[:-3]
	self.progress(cmd)

    def clear(self, widget):
	self.textbuffer.set_text('')

    def bradio(self, contype):	

	box0 = gtk.VBox()
        box1 = gtk.VBox(False, 0)
        box0.pack_start(box1)
        box1.show()

        box2 = gtk.HBox(False, 10)
        box2.set_border_width(10)
        box1.pack_start(box2, True, True, 0)
        box2.show()

        button = gtk.RadioButton(None, "mp3")
        button.connect("toggled", self.callback, contype, "mp3")
        box2.pack_start(button, True, True, 0)
        button.show()

        button = gtk.RadioButton(button, "aac")
        button.connect("toggled", self.callback, contype, "aac")
        box2.pack_start(button, True, True, 0)
        button.show()

        button = gtk.RadioButton(button, "ogg")
        button.connect("toggled", self.callback, contype, "ogg")
        box2.pack_start(button, True, True, 0)
        button.show()

        button = gtk.RadioButton(button, "mpc")
        button.connect("toggled", self.callback, contype, "mpc")
        box2.pack_start(button, True, True, 0)
        button.show()

        button = gtk.RadioButton(button, "flac")
        button.connect("toggled", self.callback, contype, "flac")
        box2.pack_start(button, True, True, 0)
        button.show()

        box2 = gtk.VBox(False, 10)
        box2.set_border_width(25)
        box1.pack_start(box2, False, True, 0)
        box2.show()

        button.set_flags(gtk.CAN_DEFAULT)
        button.show()
	self.box0 = box0
        self.box0.show()

    def convert(self, widget, contype):
	cmd=''
	filename = ""	
	if 'audvid' in contype:
		filename = re.escape(self.audvidentry.get_text())
		base, ext = os.path.split(filename)
		name = re.sub('[^.]+$', '',ext) + 'wav'
		cmd = 'mplayer -nocorrect-pts -vc null -vo null -ao pcm:fast:file=' + home + '/Desktop/' + name + ' ' + filename + ' 2>' + home + '/errors.txt && '
		format = self.avformat.get_text()
	elif 'audaud' in contype:
		filename = re.escape(self.audaudentry.get_text())
		format = self.aaformat.get_text()	
	base, ext = os.path.split(filename)
	oldext = ext.split('.')[-1]
	name2 = re.sub('[^.]+$', '',ext)
	name3 = name2
	name2 += 'wav'
	if 'audvid' in contype:
		if 'mp3' in format:
			name3 += 'mp3'
			cmd += 'lame -b 192 ' + home + '/Desktop/' + name2 + ' ' + home + '/Desktop/' + name3 + ' 2>>' + home + '/errors.txt'
		elif 'aac' in format:
			name3 += 'm4a'
			cmd += 'faac -w -s -b 192 -o ' + home + '/Desktop/' + name3 + ' ' + home + '/Desktop/' + name2 + ' 2>>' + home + '/errors.txt'
		elif 'ogg' in format:
			name3 += 'ogg'
			cmd += 'oggenc -q 5 ' + home + '/Desktop/' + name2 + ' -o '+ home + '/Desktop/' + name3 + ' 2>>' + home + '/errors.txt'
		elif 'mpc' in format:
			name3 += 'mpc'
			cmd += 'mppenc --overwrite ' + home + '/Desktop/' + name2 + ' ' + home + '/Desktop/' + name3 + ' 2>>' + home + '/errors.txt'
		elif 'flac' in format:
			name3 += 'flac'
			cmd += 'flac -f -8 ' + home + '/Desktop/' + name2 + ' -o ' + home + '/Desktop/' + name3 + ' 2>>' + home + '/errors.txt'
	elif 'audaud' in contype:
		if oldext != 'wav':
			cmd = 'mplayer -vc null -vo null -af resample=44100 -srate 44100 -ao pcm:fast:file=' + home + '/Desktop/' + name2 + ' ' + filename + ' 2>' + home + '/errors.txt && '
		if 'mp3' in format:
			name3 += 'mp3'
			cmd += 'lame -b 192 ' + home + '/Desktop/' + name2 + ' ' + home + '/Desktop/' + name3 + ' 2>>' + home + '/errors.txt'
		elif 'aac' in format:
			name3 += 'm4a'
			cmd += 'faac -w -s -b 192 -o ' + home + '/Desktop/' + name3 + ' ' + home + '/Desktop/' + name2 + ' 2>>' + home + '/errors.txt'
		elif 'ogg' in format:
			name3 += 'ogg'
			cmd += 'oggenc -q 5 ' + home + '/Desktop/' + name2 + ' -o ' + home + '/Desktop/' + name3 + ' 2>>' + home + '/errors.txt'
		elif 'mpc' in format:
			name3 += 'mpc'
			cmd += 'mppenc --overwrite ' + home + '/Desktop/' + name2 + ' ' + home + '/Desktop/' + name3 + ' 2>>' + home + '/errors.txt'
		elif 'flac' in format:
			name3 += 'flac'
			cmd += 'flac -f -8 ' + home + '/Desktop/' + name2 + ' -o ' + home + '/Desktop/' + name3 + ' 2>>' + home + '/errors.txt'
	cmd += ' && rm ' + home + '/Desktop/' + name2
	self.progress(cmd)

    def callback(self, widget, contype, data=None):
	if "ON" in (data, ("OFF","ON")[widget.get_active()]):
		if 'audaud' in contype:
			self.aaformat.set_text(data)
		elif 'audvid' in contype:		
			self.avformat.set_text(data)

    def __init__(self):

	aaformat = gtk.Entry() 
	aaformat.set_text('mp3')
	self.aaformat = aaformat

	avformat = gtk.Entry()
	avformat.set_text('mp3')
	self.avformat = avformat

        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
	self.window.set_title("MMMC - Mark's Multi Media Converter")
	self.window.set_icon_from_file(file_name)
        self.window.connect("delete_event", gtk.main_quit)
        self.window.set_border_width(10)

        table = gtk.Table(3,6)
        self.window.add(table)

        # Create a new self.notebook, place the position of the tabs
        self.notebook = gtk.Notebook()
        self.notebook.set_tab_pos(gtk.POS_TOP)
        table.attach(self.notebook, 0,6,0,1)
        self.notebook.show()
	self.show_tabs = True
	self.show_border = True

        bufferf = "Mark's Multi Media Converter"
        bufferl = "MMMC"

        self.frame = gtk.Frame(bufferf)
        self.frame.set_border_width(25)
        self.frame.set_size_request(900, 450)
        pixbuf = gtk.gdk.pixbuf_new_from_file(file_name)
        pixmap, mask = pixbuf.render_pixmap_and_mask()
      	image = gtk.Image()
      	image.set_from_pixmap(pixmap, mask)
	bigbox = gtk.VBox()
	vbox = gtk.VBox()
	hbox=gtk.HBox()
	hbox.pack_start(image)
	bigbox.pack_start(vbox)
	bigbox.pack_start(hbox)
	self.frame.add(bigbox)        
	self.frame.show_all()
        label = gtk.Label(bufferl)
        self.notebook.append_page(self.frame, label)

	bufferf = "Mark's Multi Media Converter"
        bufferl = "Audio From Video"
	self.frame = gtk.Frame(bufferf)
        self.frame.set_border_width(25)
        self.frame.set_size_request(900, 450)
        button = gtk.Button("Choose Video File")
	contype='audvid'
	button.connect("clicked", self.file_select, contype)
	filename = ""	
	button2 = gtk.Button("Extract and Convert")
	button2.connect("clicked", self.convert, contype)
	self.audvidentry = gtk.Entry()

	bigbox = gtk.VBox()
	hbox = gtk.HBox()
	hbox2 = gtk.HBox()
	hbox.pack_start(self.audvidentry, padding=10)
	hbox2.pack_start(button, padding=10)
	hbox2.pack_start(button2, padding=10)
	bigbox.pack_start(hbox, padding=10)
	bigbox.pack_start(hbox2, padding=10)

	self.bradio(contype)
	bigbox.pack_start(self.box0)
	self.frame.add(bigbox)
        self.frame.show_all()

        label = gtk.Label(bufferl)
        self.notebook.append_page(self.frame, label)

	bufferf = "Mark's Multi Media Converter"
        bufferl = "Audio to Audio"

	self.frame = gtk.Frame(bufferf)
        self.frame.set_border_width(25)
        self.frame.set_size_request(900, 450)
	contype='audaud'
        button = gtk.Button("Click To Choose Audio File")
	button.connect("clicked", self.file_select, contype)
	contype='audaud'
	button2 = gtk.Button("Convert")
	button2.connect("clicked", self.convert, contype)
	self.audaudentry = gtk.Entry()

	bigbox = gtk.VBox()
	vbox = gtk.VBox()
	vbox.pack_start(self.audaudentry, padding = 10)
	vbox.pack_start(button, padding = 10)
	hbox = gtk.HBox()
	hbox.pack_start(vbox, padding = 10)
	hbox.pack_start(button2, padding = 10)
	bigbox.pack_start(hbox, padding = 10)
	self.bradio(contype)
	bigbox.pack_start(self.box0)
	self.frame.add(bigbox)
        self.frame.show_all()

        label = gtk.Label(bufferl)
        self.notebook.append_page(self.frame, label)

	bufferf = "Mark's Multi Media Converter"
        bufferl = "Video to Video"

        self.frame = gtk.Frame(bufferf)
        self.frame.set_border_width(25)
        self.frame.set_size_request(900, 450)

        label = gtk.Label("This tab and function will become available in a future release.")
	label.show()
	self.frame.add(label)
        self.frame.show()

        label = gtk.Label(bufferl)
        self.notebook.append_page(self.frame, label)

	bufferf = "Mark's Multi Media Converter"
        bufferl = "Merge Video"

        self.frame = gtk.Frame(bufferf)
        self.frame.set_border_width(25)
        self.frame.set_size_request(900, 450)
	
	bigbox = gtk.VBox()
	bigbox.set_border_width(15)
	smallbox = gtk.HBox()
	smallbox.set_border_width(25)
	sw = gtk.ScrolledWindow()
	sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
	entrymerge = gtk.TextView()
	entrymerge.set_editable(False)
	self.textbuffer = entrymerge.get_buffer()
	sw.add(entrymerge)
	sw.show()
	entrymerge.show()
	bigbox.pack_start(sw, padding=10)
	bigbox.show_all()
	entrymerge.set_buffer(self.textbuffer)
	button = gtk.Button("Click To Add Video to List")
	contype = 'merge'
	button.connect("clicked", self.file_select, contype)
	button2 = gtk.Button("Clear Selections")
	button2.connect("clicked", self.clear)
	button3 = gtk.Button("Merge Video Files")
	button3.connect("clicked", self.filechoose)
	smallbox.pack_start(button)
	smallbox.pack_start(button2)
	smallbox.pack_start(button3)
	smallbox.show_all()
	bigbox.pack_start(smallbox)
	self.frame.add(bigbox)
        self.frame.show_all()

        label = gtk.Label(bufferl)
        self.notebook.append_page(self.frame, label)

	bufferf = "Mark's Multi Media Converter"
        bufferl = "Split Video"

        self.frame = gtk.Frame(bufferf)
        self.frame.set_border_width(25)
        self.frame.set_size_request(900, 450)
	contype='split'
	bigbox = gtk.VBox()
	box = gtk.HBox()
	box2 = gtk.HBox()
	button = gtk.Button("Click To Choose Video File")
	button.connect("clicked", self.file_select, contype)
	self.splitentry = gtk.Entry()
	self.splitentry.set_width_chars(50)
	label1 = gtk.Label("File:")
	box.pack_start(label1, expand=False, padding = 10)
	box.pack_start(self.splitentry)
	box.pack_start(button, padding = 10)
	box.show_all()
	hourbox = gtk.HBox()
	minutebox = gtk.HBox()
	splitbox = gtk.HBox()
	vertbox = gtk.HBox()
	label = gtk.Label("Enter hours:")
	self.entry2 = gtk.Entry()
	self.entry2.insert_text('00')
	self.entry2.set_width_chars(3)
	label2 = gtk.Label("Enter minutes:")
	self.entry3 = gtk.Entry()
	self.entry3.insert_text('00')
	self.entry3.set_width_chars(3)
	label.show()
	label2.show()
	button2 = gtk.Button("                                             Split  Video                                                ")
	button2.connect("clicked", self.split)
	splitbox.pack_start(button2, padding = 10)
	splitbox.show_all()
	hourbox.pack_start(label, expand = False)
	hourbox.pack_start(self.entry2, padding = 10)
	minutebox.pack_start(label2, expand = False)
	minutebox.pack_start(self.entry3, padding = 10)
	vertbox.pack_start(hourbox)
	vertbox.pack_start(minutebox, padding = 10)
	hourbox.show_all()
	minutebox.show_all()
	box2.pack_start(vertbox, padding = 10)
	box2.pack_start(splitbox)
	box2.show_all()
	bigbox.pack_start(box, padding = 10)
	bigbox.pack_start(box2, padding = 10)
	bigbox.show_all()
	self.frame.add(bigbox)
        self.frame.show_all()

        label = gtk.Label(bufferl)
        self.notebook.append_page(self.frame, label)

        button = gtk.Button("close")
        button.connect("clicked", gtk.main_quit)
	button.set_border_width(25)
        table.attach(button, 0,1,1,2)
        button.show()
        table.show()
        self.window.show()

def main():
    gtk.main()
    return 0

if __name__ == "__main__":
    NotebookExample()
    main()
